Segfault with comparison to None

Bug #884619 reported by Daniele Varrazzo on 2011-11-01
12
This bug affects 1 person
Affects Status Importance Assigned to Milestone
egenix-mx-base (Ubuntu)
Undecided
Unassigned
Oneiric
Undecided
Unassigned

Bug Description

mx.DateTime object segfaul when compared to none. This is a known bug in mxDateTime 3.2.0 and already fixed upstream (see http://www.egenix.com/products/python/mxBase/mxDateTime/changelog.html).

To reproduce the bug:

    $ python -c "from mx.DateTime import Date; Date(2011,1,1) == None"
    Segmentation fault

Please update to package version 3.2.1. Thanks.

ProblemType: Bug
DistroRelease: Ubuntu 11.10
Package: python-egenix-mxdatetime 3.2.0-1
ProcVersionSignature: Ubuntu 3.0.0-12.20-generic 3.0.4
Uname: Linux 3.0.0-12-generic i686
NonfreeKernelModules: nvidia
ApportVersion: 1.23-0ubuntu3
Architecture: i386
Date: Tue Nov 1 07:27:32 2011
InstallationMedia: Ubuntu 10.10 "Maverick Meerkat" - Release i386 (20101007)
ProcEnviron:
 PATH=(custom, user)
 LANG=en_GB.UTF-8
 SHELL=/bin/bash
SourcePackage: egenix-mx-base
UpgradeStatus: Upgraded to oneiric on 2011-10-28 (4 days ago)

Evan Broder (broder) wrote :

This has already been fixed in the 3.2.1 upstream release, currently in Precise as 3.2.1-1, so I'm closing the bug against the development release.

I've gone ahead and uploaded an microrelease update of 3.2.1 to oneiric-proposed. Somebody from the SRU team should be through to review the SRU. In the mean time, please update the bug description with a few sentences for each of the 5 points mentioned in step 2 of https://wiki.ubuntu.com/StableReleaseUpdates#Procedure

Changed in egenix-mx-base (Ubuntu):
status: New → Fix Released
Changed in egenix-mx-base (Ubuntu Oneiric):
status: New → Confirmed
Thomas Ward (teward) wrote :

[SRU]

[Impact]
Frequency of the bug is rare, or under certain cases as described in this bug. In Oneiric, anything using egenix-mx-base for mx.DateTime is vulnerable to this occurrence.

[Development Fix]
This bug was filed to the upstream source, and was fixed with the release of 3.2.1 to Debian, which was subsequently synced into Precise during the last sync.

[Stable Fix]
After reviewing the differences in the code between Debian Sid / Precise and the versions in Oneiric, there were additional code changes to the upstream version. Finding the exact specific place in the code to patch this is time consuming, and after consulting with Evan Broder, it would be more prudent to update to 3.2.1 that is in Precise (which is confirmed to build and work without changes in Oneiric)

[Test Case]
A test case to reproduce the errors in this bug in 3.2.0 are here (the result is "Segmentation Fault" in 3.2.0 or earlier):

$ python -c "from mx.DateTime import Date; Date(2011,1,1) == None"

According to the bug poster, who tested my original "backported" version which I used to test the building within Oneiric, the version of 3.2.1 does *not* have this bug, and operates as is expected, not producing the segfault

[Regression Potential]
Severity of regressions is minimal, as the changes to the upstream version are minor between 3.2.0 and 3.2.1 as it was a microrelease update.

Evan Broder (broder) wrote :

To clarify above, I chose to update to 3.2.1 not because it's difficult to isolate the relevant patch, but because all of the changes in the 3.2.1 release fix bugs in the code.

If still relevant, I've tested Thomas' backport (https://launchpad.net/~trekcaptainusa-tw/+archive/egenix-mx-base) and it works as expected both with i386 and IA64 architectures. I've tested both this bug's test case and compiled and executed the psycopg2 test suite with mx support.

Thomas Ward (teward) wrote :

Daniele, this is being taken care of, its closed against the project because 3.2.1 - 3.2.3 fix the code. The SRU will update oneiric's package of egenix-mx-base though with the 3.2.1 code, via the oneiric-updates directory. I emailed you regarding this as well, to clarify what we're doing with the bug, so this *is* being fixed, but in a different method (since the project itself already has a stable release that has fixed this, 3.2.1, and current in Debian is 3.2.1.

We are taking a different route. We're going to have 3.2.1 added to
oneiric-updates, per the SRU (Stable Release Update) method. Broder,
who's a MOTU and a person who has some say, is sponsoring the SRU,
which gives it a very good chance of being updated.

See the update i put to your response, and let it simmer because the
update *will* occur eventually in the oneiric-updates repository

On Tue, Mar 6, 2012 at 4:52 PM, Daniele Varrazzo
<email address hidden> wrote:
> If still relevant, I've tested Thomas' backport (https://launchpad.net
> /~trekcaptainusa-tw/+archive/egenix-mx-base) and it works as expected
> both with i386 and IA64 architectures. I've tested both this bug's test
> case and compiled and executed the psycopg2 test suite with mx support.
>
> --
> You received this bug notification because you are subscribed to the bug
> report.
> https://bugs.launchpad.net/bugs/884619
>
> Title:
>  Segfault with comparison to None

> Status in “egenix-mx-base” package in Ubuntu:
>  Fix Released
> Status in “egenix-mx-base” source package in Oneiric:
>  Confirmed
>
> Bug description:
>  mx.DateTime object segfaul when compared to none. This is a known bug
>  in mxDateTime 3.2.0 and already fixed upstream (see
>  http://www.egenix.com/products/python/mxBase/mxDateTime/changelog.html).
>
>  To reproduce the bug:
>
>      $ python -c "from mx.DateTime import Date; Date(2011,1,1) == None"
>      Segmentation fault
>
>  Please update to package version 3.2.1. Thanks.
>
>  ProblemType: Bug
>  DistroRelease: Ubuntu 11.10
>  Package: python-egenix-mxdatetime 3.2.0-1
>  ProcVersionSignature: Ubuntu 3.0.0-12.20-generic 3.0.4
>  Uname: Linux 3.0.0-12-generic i686
>  NonfreeKernelModules: nvidia
>  ApportVersion: 1.23-0ubuntu3
>  Architecture: i386
>  Date: Tue Nov  1 07:27:32 2011
>  InstallationMedia: Ubuntu 10.10 "Maverick Meerkat" - Release i386 (20101007)
>  ProcEnviron:
>   PATH=(custom, user)
>   LANG=en_GB.UTF-8
>   SHELL=/bin/bash
>  SourcePackage: egenix-mx-base
>  UpgradeStatus: Upgraded to oneiric on 2011-10-28 (4 days ago)
>
> To manage notifications about this bug go to:
> https://bugs.launchpad.net/ubuntu/+source/egenix-mx-base/+bug/884619/+subscriptions

Hello Daniele, or anyone else affected,

Accepted egenix-mx-base into oneiric-proposed. The package will build now and be available in a few hours. Please test and give feedback here. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Thank you in advance!

Changed in egenix-mx-base (Ubuntu Oneiric):
status: Confirmed → Fix Committed
tags: added: verification-needed

The fix for the this bug has been awaiting testing feedback in the -proposed repository for oneiric for more than 90 days. Please test this fix and update the bug appropriately with the results. In the event that the fix for this bug is still not verified 15 days from now the package will be removed from the -proposed repository.

-proposed package downloaded, installed and tested. Works as expected.

tags: added: verification-done
removed: verification-needed

The verification of this Stable Release Update has completed successfully and the package has now been released to -updates. Subsequently, the Ubuntu Stable Release Updates Team is being unsubscribed and will not receive messages about this bug report. In the event that you encounter a regression using the package from -updates please report a new bug using ubuntu-bug and tag the bug report regression-update so we can easily find any regresssions.

Launchpad Janitor (janitor) wrote :

This bug was fixed in the package egenix-mx-base - 3.2.1-1~oneiric0.1

---------------
egenix-mx-base (3.2.1-1~oneiric0.1) oneiric-proposed; urgency=low

  * Backport to Oneiric as an SRU to fix segfault. (LP: #884619)
  * No other source changes required.

egenix-mx-base (3.2.1-1) unstable; urgency=low

  * New upstream release (closes: #641441)
 -- Evan Broder <email address hidden> Tue, 06 Mar 2012 10:31:01 -0800

Changed in egenix-mx-base (Ubuntu Oneiric):
status: Fix Committed → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers